﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace Fresnel
{
    public partial class UserControl1 : UserControl
    {
        public MainWindow UC;
        public Boolean BEdit = false;


        public UserControl1()
        {
            InitializeComponent();
        }

        public void SetUC()
        {
            int N = Convert.ToInt32(UC.TextBox1.Text);
            dataGridView1.RowCount = N + 4;
            dataGridView1.Rows[0].Cells[0].Value = "記号";
            dataGridView1.Rows[0].Cells[1].Value = "Pr";
            dataGridView1.Rows[0].Cells[2].Value = "Pi";
            dataGridView1.Rows[0].Cells[3].Value = "Px1";
            dataGridView1.Rows[0].Cells[4].Value = "Px2";
            dataGridView1.Rows[0].Cells[5].Value = "Py1";
            dataGridView1.Rows[0].Cells[6].Value = "Py2";

            dataGridView1.Rows[1].Cells[0].Value = "単位";
            dataGridView1.Rows[1].Cells[1].Value = "相対";
            dataGridView1.Rows[1].Cells[2].Value = "相対";
            dataGridView1.Rows[1].Cells[3].Value = "μm";
            dataGridView1.Rows[1].Cells[4].Value = "μm";
            dataGridView1.Rows[1].Cells[5].Value = "μm";
            dataGridView1.Rows[1].Cells[6].Value = "μm";
            int i;

            for (i = 1; i <= N; i++) { dataGridView1.Rows[1 + i].Cells[0].Value = Convert.ToString(i); }
        }

        public void SetData()
        {
            dataGridView1.Rows[2].Cells[1].Value = "1";
            dataGridView1.Rows[2].Cells[2].Value = "0";
            dataGridView1.Rows[2].Cells[3].Value = "-1.5";
            dataGridView1.Rows[2].Cells[4].Value = "1.5";
            dataGridView1.Rows[2].Cells[5].Value = "-7.5";
            dataGridView1.Rows[2].Cells[6].Value = "7.5";

            dataGridView1.Rows[3].Cells[1].Value = "1";
            dataGridView1.Rows[3].Cells[2].Value = "0";
            dataGridView1.Rows[3].Cells[3].Value = "-7.5";
            dataGridView1.Rows[3].Cells[4].Value = "-4.5";
            dataGridView1.Rows[3].Cells[5].Value = "-7.5";
            dataGridView1.Rows[3].Cells[6].Value = "7.5";

            dataGridView1.Rows[4].Cells[1].Value = "1";
            dataGridView1.Rows[4].Cells[2].Value = "0";
            dataGridView1.Rows[4].Cells[3].Value = "4.5";
            dataGridView1.Rows[4].Cells[4].Value = "7.5";
            dataGridView1.Rows[4].Cells[5].Value = "-7.5";
            dataGridView1.Rows[4].Cells[6].Value = "7.5";
        }

        

        private void dataGridView1_KeyDown(object sender, KeyEventArgs e)
        {
            var k = e.KeyCode;
            if (k == Keys.F1)//コピー
            {
                var cc = dataGridView1.CurrentCellAddress;
                if (dataGridView1.Rows[cc.Y].Cells[cc.X].Value != null)
                {
                    System.Windows.Forms.Clipboard.SetDataObject(new DataObject(dataGridView1.Rows[cc.Y].Cells[cc.X].Value));
                }
            }

            if (k == Keys.F2)//ペースト
            {
                var cc = dataGridView1.CurrentCellAddress;
                var objData = System.Windows.Forms.Clipboard.GetDataObject();

                if (objData.GetDataPresent(DataFormats.StringFormat))
                {
                    String str = (String)objData.GetData(DataFormats.StringFormat);
                    if (str != "dataGridView1.Rows[cc.Y].Cells[cc.X].Value")
                    {
                        dataGridView1.Rows[cc.Y].Cells[cc.X].Value = str;
                    }
                }
            }

            if (k == Keys.F3)//クリア
            {
                var cc = dataGridView1.CurrentCellAddress;
                dataGridView1.Rows[cc.Y].Cells[cc.X].Value = "";
            }
        }

        private void dataGridView1_CellBeginEdit(object sender, DataGridViewCellCancelEventArgs e)
        {
            BEdit = true;
        }

        private void dataGridView1_CellEndEdit(object sender, DataGridViewCellEventArgs e)
        {
            BEdit = false;
            dataGridView1.Invalidate();

        }
    }
}
