﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Shapes;
using System.Windows.Forms;


namespace Fresnel
{
    /// <summary>
    /// Window2.xaml の相互作用ロジック
    /// </summary>
    public partial class Window2 : Window
    {
        Color[] c = new Color[18];

        public Window2()
        {
            InitializeComponent();
        }

        private void Button1_Click(object sender, RoutedEventArgs e)
        {
            this.Close();
        }

        public void Draw(DataGridView dataGridView1)
        {
            int i, j,k,Ni,Nj;
            double II;
            SetMyC();
            int P = 4;

            Ni = dataGridView1.ColumnCount - 1;
            Nj = dataGridView1.RowCount - 1;

            Path[,] myPath = new Path[Ni + 2, Nj + 2];
            RectangleGeometry[,] myGeometry = new RectangleGeometry[Ni + 2, Nj + 2];

            double IImax = 0;
            for (i = 1; i <= Ni; i++)
            {
                for (j = 1; j <= Nj; j++)
                {
                    if (Convert.ToDouble(dataGridView1.Rows[j].Cells[i].Value) > IImax)
                    {IImax=Convert.ToDouble(dataGridView1.Rows[j].Cells[i].Value);}
                }
            }

            for (i = 1; i <= Ni; i++)
            {
                for (j = 1; j <= Nj; j++)
                {
                    myPath[i, j] = new Path();
                    myGeometry[i, j] = new RectangleGeometry();
                    II =Convert.ToDouble( dataGridView1.Rows[j].Cells[i].Value);
                    k = (int)(II * 17/IImax);
                    myPath[i, j].Fill =new SolidColorBrush(c[17 - k]);
                    myGeometry[i, j].Rect = new System.Windows.Rect(50 + P * i, 50 + P * j, P, P);
                    myPath[i, j].Data = myGeometry[i, j];
                    Grid1.Children.Add(myPath[i, j]);

                }
            }


        }

        public void SetMyC()
        {
            int i;
            for (i = 0; i < 3; i++)
            {
                c[i] = Color.FromArgb(255, Convert.ToByte(255 - 75 * i), 0, 0);
                c[i + 3] = Color.FromArgb(255, Convert.ToByte(150 - 40 * i), Convert.ToByte(150 - 40 * i), 0);
                c[i + 6] = Color.FromArgb(255, 0, Convert.ToByte(255 - 75 * i), 0);
                c[i + 9] = Color.FromArgb(255, 0, Convert.ToByte(150 - 40 * i), Convert.ToByte(150 - 40 * i));
                c[i + 12] = Color.FromArgb(255, 0, 0, Convert.ToByte(255 - 75 * i));
                c[i + 15] = Color.FromArgb(255, Convert.ToByte(150 - 40 * i), 0, Convert.ToByte(150 - 40 * i));
            }
        }
    }
}
